<?php

declare(strict_types=1);

use LeadDeskClasses\MaxSubarrayAction;
use PHPUnit\Framework\TestCase;

class MaxSubarrayTest extends TestCase
{
    /** 
     * @covers MaxSubarrayAction::contiguous
     */
    public function testMaxSubarrayAction(): void
    {
        $subarray_action = new MaxSubarrayAction();

        $input = [null, null, null, null];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(0, $sum, 'Checkng max sum');

        $input = [null, -1, 1, 5, -6, 3];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(6, $sum, 'Checkng max sum');

        $input = [null, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 
        3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, 
        -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 
        5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23,null, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 
        3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, 
        -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 
        5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23,
        null, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 
        3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, 
        -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 
        5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23,null, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 
        3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, 
        -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 
        5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23,null, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 
        3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, 
        -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 
        8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 
        5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 
        1, 1, 3, 5, -6, 3, 8, 9, 23, -1, 1, 1, 3, 5, -6, 3, 8, 9, 23];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(6210, $sum, 'Checkng max sum');

        $input = [-9, 23];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(23, $sum, 'Checkng max sum');
 
        $input = [-9, 15];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(15, $sum, 'Checkng max sum');

        $input = [-9, -15, -5, -8, -12];
        $sum = $subarray_action->contiguous($input);
        self::assertEquals(-49, $sum, 'Checkng max sum');
    }
}